//+------------------------------------------------------------------+
//|                                             Inzider EA v0.50.mq4 |
//|                                       Copyright  2008 Tom Balfe |
//|                   http://www.forex-tsd.com/members/nittany1.html |
//|                                                                  |
//| MACD and stochastics based Expert Advisor. I've included         |
//| directional index to try to filter out some bad trades. This     |
//| EA is meant for 1 hour or 4 hour.                                |
//+------------------------------------------------------------------+
//| I've set this up to check the indicators every 10 minutes. If    |
//| you're convinced you want to try this on a timeframe shorter     |
//| than 1 hour, please change the WaitMinutes to something less     |
//| stock setting.                                                   |
//+------------------------------------------------------------------+
//| If you use this EA on more than one chart, or you have more than |
//| one EA on a given currency pair make sure to remember to change  |
//| the MagicNumber.                                                 |
//|                                                                  |
//| For Example: Inzider EA on 1 hour EUR/USD MagicNumber 255522     |
//| an also:     Inzider EA on 4 hour GBP/USD MagicNumber 211112     |
//|                                                                  |
//| It doesn't matter what you change the magic number to as long as |
//| it's unique. That way the expert won't effect itself on another  |
//| currency pair.                                                   |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008 Tom Balfe"
#property link      "http://www.forex-tsd.com/members/nittany1.html"

//+------------------------------------------------------------------+
//| USER ADJUSTABLE STUFF                                            |
//+------------------------------------------------------------------+

extern  string  TopOfSetting          = "=== Inzider EA v.50 ===";
extern  int     MagicNumber           = 255522;
extern  int     WaitMinutes           = 10; 

extern  string  Order_Settings        = "=== Order Settings ===";
extern  double  StaticLots            = 0.1;
extern  int     Slippage              = 5;
extern  int     TP                    = 50;
extern  int     SL                    = 25;

extern  string  MM_Settings           = "=== Money Management ===";
extern  bool    UseMM                 = false;
extern  int     PercentAtRisk         = 3;

extern  string  MACD_Settings         = "=== MACD Settings ===";
extern  int     FastEMA               = 8;
extern  int     SlowEMA               = 16;
extern  int     SMA                   = 4;

extern  string  Stoch_Settings        = "=== Stochastic Settings ===";
extern  int     PercentK              = 8;
extern  int     PercentD              = 3;
extern  int     Slowing               = 3;

//+------------------------------------------------------------------+
//| DON'T CHANGE BELOW HERE                                          |
//+------------------------------------------------------------------+
//| Program initializes and deinitializes here.                      |
//+------------------------------------------------------------------+
string        EAComment   = "Inzider EA v0.50";
int           OpenOrders  = 1;

int init()
  {

  return(0);
  }

int deinit()
  {
    if (TotalOpenOrders() > 0)
    {
    CloseAll();
    } 
   
  return(0);
  }
  
//+------------------------------------------------------------------+
//| MAIN LOOP                                                        |
//+------------------------------------------------------------------+
//| Program spends most of its life going through this main loop.    |
//+------------------------------------------------------------------+
int start()
  {
  //--- MACD
  double MACDValue    = iMACD(NULL,0,FastEMA,SlowEMA,SMA,PRICE_MEDIAN,MODE_MAIN,0);
  double MACDSignal   = iMACD(NULL,0,FastEMA,SlowEMA,SMA,PRICE_MEDIAN,MODE_SIGNAL,0);
  
  //--- Stochastics
  double sMain        = iStochastic(NULL,0,PercentK,PercentD,Slowing,MODE_SMA,0,MODE_MAIN,0);
  double sSignal      = iStochastic(NULL,0,PercentK,PercentD,Slowing,MODE_SMA,0,MODE_SIGNAL,0);
  
  //--- Directional Index
  double di_p         = iADX(NULL,0,14,PRICE_CLOSE,1,0); // DI+ 
  double di_m         = iADX(NULL,0,14,PRICE_CLOSE,2,0); // DI-   
   
  //------------------- order management -------------------//
  if (ElapsedTimeCheck(WaitMinutes) == true) {
  
    //---------------- check indicators and look for a CLOSE ---//
    if (TotalOpenOrders() == OpenOrders)
    {
      if (OrderType() == OP_BUY) {
        if (sMain<sSignal) { CloseAll(); }
        }
      if (OrderType() == OP_SELL) {
        if (sMain>sSignal) { CloseAll(); }
        }
    } // end of if we have orders
    
    //---------------- check indicators and look for a ORDER ENTRY ---//
    if (TotalOpenOrders() < OpenOrders)
    {
      if ((MACDValue>MACDSignal)&&(sMain>sSignal)&&(di_p>di_m)) // BUY
       {
       OrderSend(Symbol(),OP_BUY,LotSize(),Ask,Slippage,Ask-SL*Point,Ask+TP*Point,EAComment,MagicNumber,0,Lime);  
       } 
      if ((MACDValue<MACDSignal)&&(sMain<sSignal)&&(di_m>di_p)) // SELL
       {
       OrderSend(Symbol(),OP_SELL,LotSize(),Bid,Slippage,Bid+SL*Point,Ask-TP*Point,EAComment,MagicNumber,0,Red);
       }
    } // end of if no orders exist
  } // end of if elapsed time has passed
  
  ShowInfo();
  
  return(0);
  } // end of main loop

//+------------------------------------------------------------------+
//| COMMON FUNCTIONS                                                 |
//+------------------------------------------------------------------+
//| The expert will call these from the main loop.                   |
//+------------------------------------------------------------------+

//+-----------------------------------------------------+
//|           trade interval                            |
//+-----------------------------------------------------+
bool ElapsedTimeCheck(int mins)
{
  static datetime OldTime;
 
  if (OldTime == 0)
    OldTime = TimeCurrent() + mins * 60; // initialised once...

  if (TimeCurrent() >= OldTime) 
  {
    OldTime = TimeCurrent() + mins * 60;
    bool cond = true;
  }
  else cond = false;
 
 return(cond);
}

//+-----------------------------------------------------+
//|           calculate lot size                        |
//+-----------------------------------------------------+
double LotSize()
{
  if (UseMM == true) 
    { double Lots = MathCeil(AccountFreeMargin() *  PercentAtRisk / 1000) / 100; }
  
  else { Lots = StaticLots; }
  
  return(Lots);  
}

//+-----------------------------------------------------+
//|           close all                                 |
//+-----------------------------------------------------+
//| Finds any open orders & closes them                 |
//+-----------------------------------------------------+
void CloseAll()
{
  int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type = OrderType();
    
    if (OrderSymbol()==Symbol() && (OrderMagicNumber() == MagicNumber))  
    {
      //-- Close open BUYs
      if (type == OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,CornflowerBlue);
      //-- Close open SELLS
      if (type == OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,CornflowerBlue);
    }
  }
  return;
}

//+-----------------------------------------------------+
//|           calculate open orders                     |
//+-----------------------------------------------------+
int TotalOpenOrders()
{
  int j = 0;
  j=OrdersTotal();
  int TotalOpenOrders = 0;
   
  if(j==0) { return (0); }
  
  else
  {
    for(;j>=0;j--)
      {
      RefreshRates();
      OrderSelect(j,SELECT_BY_POS);
      if(OrderMagicNumber()==MagicNumber)
      {
        TotalOpenOrders++;
      }
    }
  }
  return(TotalOpenOrders);
}

//+-----------------------------------------------------+
//|           show summary panel on chart               |
//+-----------------------------------------------------+
void ShowInfo()
{
  Comment("...::: Inzider EA v0.50 :::...\n",
          "Copyright  2008 Tom Balfe\n",
          "Currency Pair: ", Symbol(),"\n",
          "Price:  ",NormalizeDouble(Bid,4),"\n",
          "Date: ",Month(),"-",Day(),"-",Year()," Server Time: ",Hour(),":",Minute(),":",Seconds(),"\n",
          "Minimum Lot Size: ",MarketInfo(Symbol(),MODE_MINLOT));
  return(0);
}